#include<bits/stdc++.h>
using namespace std;


#define INT_SIZE 32

//pravili smo s nisuuuu
//ovo je za 4 poena hahahaha
struct TrieNode
{
    int value;
    TrieNode *arr[2];
};
 
TrieNode *newNode()
{
    TrieNode *temp = new TrieNode;
    temp->value = 0;
    temp->arr[0] = temp->arr[1] = NULL;
    return temp;
}
 
//verujem na algoritam
void insert(TrieNode *root, int pre_xor)
{
    TrieNode *temp = root;
 
    for (int i=INT_SIZE-1; i>=0; i--)
    {
        bool val = pre_xor & (1<<i);
        if (temp->arr[val] == NULL)
            temp->arr[val] = newNode();
 
        temp = temp->arr[val];
    }
 
    temp->value = pre_xor;
}
 
int query(TrieNode *root, int pre_xor)
{
    TrieNode *temp = root;
    for (int i=INT_SIZE-1; i>=0; i--)
    {
        bool val = pre_xor & (1<<i);

        if (temp->arr[1-val]!=NULL)
            temp = temp->arr[1-val];
 
        else if (temp->arr[val] != NULL)
            temp = temp->arr[val];
    }
    return pre_xor^(temp->value);
}
 
//sad treba da radi
int maxSubarrayXOR(int arr[], int n)
{
    //pravim ovaj trie koji sam koristio pre 3 godine s Nisica xdd
    TrieNode *root = newNode();
    insert(root, 0);
 
    int result = INT_MIN;
    int pre_xor = 0;
 
    for (int i=0; i<n; i++)
    {
        pre_xor = pre_xor^arr[i];
        insert(root, pre_xor);
        result = max(result, query(root, pre_xor));
    }
    return result;
}
//do ovde je za 4 poena

//aj sadsolve2



void solve1(vector<int> b)
{
    //posto su svi a[i] 1 to znaci da trazimo segment l r gde je niz b najjaci
    cout << maxSubarrayXOR(b,b.size()) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int n;
    vector<int> a(n);
    vector<int> b(n);
    cin >> n;
    int testcase1 = 1;
    int testcase2 = 1;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        testcase1 &= a[i];
        
    }
    for(int i = 0; i < n; i++)
    {
        cin >> b[i];
        //istu foru koristimo i da proverimo za b niz
        testcase2 &= 1;
    }


    if(testcase1 == 1)
        solve1(b);
    else if(testcase2 == 1)
        solve2(a);
    //odustao sam hahaha da citam nekad

    
    //trebaju mi and i xor
}